<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcSteer Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcSteer Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcSteer" --><!-- doxytag: inherits="iBase" -->
<p>This is a steering property class.  
 <a href="structiPcSteer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="steer_8h_source.html">propclass/steer.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcSteer:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcSteer.png" usemap="#iPcSteer_map" alt=""/>
  <map id="iPcSteer_map" name="iPcSteer_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,60,24"/>
</map>
 </div></div>

<p><a href="structiPcSteer-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a18b94aee484d097c04a55eaa72c6d01b">CheckArrivalOff</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets arrival checking off.  <a href="#a18b94aee484d097c04a55eaa72c6d01b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a179522ffff7b76130865ea72f6a91a13">CheckArrivalOn</a> (float radius)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets arrival checking on with arrival_radius = radius.  <a href="#a179522ffff7b76130865ea72f6a91a13"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#ab3fec35668691fe6ae05ab26f1cf6e86">CohesionOff</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Cohesion off.  <a href="#ab3fec35668691fe6ae05ab26f1cf6e86"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a45c0faec81ffa56766d44c1c78333b89">CohesionOn</a> (<a class="el" href="structiCelEntityList.html">iCelEntityList</a> *targets, float radius, float max_radius, float weight)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Cohesion on.  <a href="#a45c0faec81ffa56766d44c1c78333b89"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a6fed0d2267e98cc8deefed6e39d0ffbf">CollisionAvoidanceOff</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Collision Avoidance off.  <a href="#a6fed0d2267e98cc8deefed6e39d0ffbf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a3cc5f83c9cc7db1403ae9d0bf53191fb">CollisionAvoidanceOn</a> (float lookahead, float weight)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets collision avoidance on.  <a href="#a3cc5f83c9cc7db1403ae9d0bf53191fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#ab372a22ea5d77c4c959c6084d8a8bc09">DirectionMatchingOff</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Direction Matching off.  <a href="#ab372a22ea5d77c4c959c6084d8a8bc09"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a77c535b9b4cba6cd8287f176eebd355a">DirectionMatchingOn</a> (<a class="el" href="structiCelEntityList.html">iCelEntityList</a> *targets, float weight)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Direction Matching on.  <a href="#a77c535b9b4cba6cd8287f176eebd355a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a832c144d09e9e94832861e73fa97869e">Flee</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;position)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move away from the specified position.  <a href="#a832c144d09e9e94832861e73fa97869e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a76f68a340d625a4fc13c3c6908560968">GetPosition</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the end position that we want to move to.  <a href="#a76f68a340d625a4fc13c3c6908560968"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a6c64a03ed79142641b894e4afede85d5">GetSector</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the end sector that we want to move to.  <a href="#a6c64a03ed79142641b894e4afede85d5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a5eb951aa306ac8dacc60529f0f6219bf">Interrupt</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interrupt a movement.  <a href="#a5eb951aa306ac8dacc60529f0f6219bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a3726dbb6f2cdcbfddf00bfdf7e87922c">IsMoving</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if currently moving.  <a href="#a3726dbb6f2cdcbfddf00bfdf7e87922c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a818c245703a5d6161741a869268aac22">Pursue</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *target, float max_prediction)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move to the specified targets position.  <a href="#a818c245703a5d6161741a869268aac22"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a5a475bad4b23a3bf8afdbbbdde1b7312">RandomBinomial</a> (float rate)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a random number using a random binomial.  <a href="#a5a475bad4b23a3bf8afdbbbdde1b7312"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a0bf80ce6090221e90ab193110be32996">Seek</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;position)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move to the specified position.  <a href="#a0bf80ce6090221e90ab193110be32996"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a58bb89b7931f71aff132c9b28a6dcaac">SeparationOff</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Separation off.  <a href="#a58bb89b7931f71aff132c9b28a6dcaac"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#aa10962cc8efce907fe563dfb73539231">SeparationOn</a> (<a class="el" href="structiCelEntityList.html">iCelEntityList</a> *targets, float radius, float weight)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets Separation on.  <a href="#aa10962cc8efce907fe563dfb73539231"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a284fa5c89e4d1a1db57b95cd11c480aa">SetDelayRecheck</a> (int delay)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets current delay_recheck.  <a href="#a284fa5c89e4d1a1db57b95cd11c480aa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcSteer.html#a0394f8bb7728b4a63125cf03f2b948c2">Vigilant</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Stay vigilant about changes around.  <a href="#a0394f8bb7728b4a63125cf03f2b948c2"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a steering property class. </p>
<p>It works closely with pclinmove and pcactormove in order to move an object from one position to another while checking collision detection along the way.</p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.move.arrived' (old 'pcsteer_arrived'): arrived at final position.</li>
<li>'cel.move.avoiding_collision' (old 'pcsteer_avoiding_collision'): ?</li>
<li>'cel.move.interrupted' (old 'pcsteer_interrupted'): movement has been interrupted.</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.move.steer.action.' if you want to access this action through a message):</p>
<ul>
<li>Seek: parameters 'sectorname' (string), 'position' (vector3).</li>
<li>Flee: parameters 'sectorname' (string), 'position' (vector3).</li>
<li>Pursue: parameters 'target' (iCelEntity*), 'max_prediction' (float),</li>
<li>Interrupt: interrupt the current movement. This property class supports the following properties:</li>
<li>position (vector3, read only): current end position.</li>
<li>sqradius (float, read/write): current squared radius.</li>
<li>moving (bool, read only): returns true if currently moving.</li>
<li>cur_position (vector3, read only): current position.</li>
<li>cur_direction (vector3, read only): current direction.</li>
<li>check_cohesion (bool, read/write): returns true if currently checking for cohesion.</li>
<li>check_separation (bool, read/write): returns true if currently checking for separation.</li>
<li>check_arrival (bool, read/write): returns true if currently checking for arrival.</li>
<li>check_dm (bool, read/write): returns true if currently checking for direction matching.</li>
<li>arrival_radius (bool, read/write): current arrival radius.</li>
<li>collision_avoidance (bool, read only): returns true if currently checking for collisions.</li>
<li>ca_lookahead (float, read/write): current collision avoidance max lookahead.</li>
<li>separation_radius (float, read/write): current min radius before separating.</li>
<li>cohesion_radius (float, read/write): current max radius before activating cohesion.</li>
<li>separation_weight (float, read/write): current separation weight.</li>
<li>cohesion_weight (float, read/write): current cohesion weight.</li>
<li>dm_weight (float, read/write): current direction matching weight.</li>
<li>pursue_max_prediction (float, read/write): current pursue max prediction.</li>
<li>current_action (int, read only): current action code value.</li>
<li>delay_recheck (int, read/write): current delay before calling TickOnce. </li>
</ul>

<p>Definition at line <a class="el" href="steer_8h_source.html#l00067">67</a> of file <a class="el" href="steer_8h_source.html">steer.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a18b94aee484d097c04a55eaa72c6d01b"></a><!-- doxytag: member="iPcSteer::CheckArrivalOff" ref="a18b94aee484d097c04a55eaa72c6d01b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a18b94aee484d097c04a55eaa72c6d01b">iPcSteer::CheckArrivalOff</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets arrival checking off. </p>

</div>
</div>
<a class="anchor" id="a179522ffff7b76130865ea72f6a91a13"></a><!-- doxytag: member="iPcSteer::CheckArrivalOn" ref="a179522ffff7b76130865ea72f6a91a13" args="(float radius)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a179522ffff7b76130865ea72f6a91a13">iPcSteer::CheckArrivalOn</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>radius</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets arrival checking on with arrival_radius = radius. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">radius</td><td>sets current arrival_radius </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab3fec35668691fe6ae05ab26f1cf6e86"></a><!-- doxytag: member="iPcSteer::CohesionOff" ref="ab3fec35668691fe6ae05ab26f1cf6e86" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#ab3fec35668691fe6ae05ab26f1cf6e86">iPcSteer::CohesionOff</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Cohesion off. </p>

</div>
</div>
<a class="anchor" id="a45c0faec81ffa56766d44c1c78333b89"></a><!-- doxytag: member="iPcSteer::CohesionOn" ref="a45c0faec81ffa56766d44c1c78333b89" args="(iCelEntityList *targets, float radius, float max_radius, float weight)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a45c0faec81ffa56766d44c1c78333b89">iPcSteer::CohesionOn</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntityList.html">iCelEntityList</a> *&#160;</td>
          <td class="paramname"><em>targets</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>radius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max_radius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>weight</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Cohesion on. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">targets</td><td>sets current cohesion_targets </td></tr>
    <tr><td class="paramname">radius</td><td>sets current cohesion_radius </td></tr>
    <tr><td class="paramname">max_radius</td><td>sets current cohesion_max_radius </td></tr>
    <tr><td class="paramname">weight</td><td>sets current cohesion_weight </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6fed0d2267e98cc8deefed6e39d0ffbf"></a><!-- doxytag: member="iPcSteer::CollisionAvoidanceOff" ref="a6fed0d2267e98cc8deefed6e39d0ffbf" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a6fed0d2267e98cc8deefed6e39d0ffbf">iPcSteer::CollisionAvoidanceOff</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Collision Avoidance off. </p>

</div>
</div>
<a class="anchor" id="a3cc5f83c9cc7db1403ae9d0bf53191fb"></a><!-- doxytag: member="iPcSteer::CollisionAvoidanceOn" ref="a3cc5f83c9cc7db1403ae9d0bf53191fb" args="(float lookahead, float weight)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a3cc5f83c9cc7db1403ae9d0bf53191fb">iPcSteer::CollisionAvoidanceOn</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>lookahead</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>weight</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets collision avoidance on. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lookahead</td><td>sets current ca_lookahead </td></tr>
    <tr><td class="paramname">weight</td><td>sets current ca_weight </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab372a22ea5d77c4c959c6084d8a8bc09"></a><!-- doxytag: member="iPcSteer::DirectionMatchingOff" ref="ab372a22ea5d77c4c959c6084d8a8bc09" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#ab372a22ea5d77c4c959c6084d8a8bc09">iPcSteer::DirectionMatchingOff</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Direction Matching off. </p>

</div>
</div>
<a class="anchor" id="a77c535b9b4cba6cd8287f176eebd355a"></a><!-- doxytag: member="iPcSteer::DirectionMatchingOn" ref="a77c535b9b4cba6cd8287f176eebd355a" args="(iCelEntityList *targets, float weight)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a77c535b9b4cba6cd8287f176eebd355a">iPcSteer::DirectionMatchingOn</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntityList.html">iCelEntityList</a> *&#160;</td>
          <td class="paramname"><em>targets</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>weight</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Direction Matching on. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">targets</td><td>sets current dm_targets </td></tr>
    <tr><td class="paramname">weight</td><td>sets current dm_weight </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a832c144d09e9e94832861e73fa97869e"></a><!-- doxytag: member="iPcSteer::Flee" ref="a832c144d09e9e94832861e73fa97869e" args="(iSector *sector, const csVector3 &amp;position)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcSteer.html#a832c144d09e9e94832861e73fa97869e">iPcSteer::Flee</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move away from the specified position. </p>
<p>When you call this function this property class will attempt to move the linmove to oposite of the specified position. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcsteer_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sector</td><td>is the desired sector to move away from. </td></tr>
    <tr><td class="paramname">position</td><td>is the desired position to move away from. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a76f68a340d625a4fc13c3c6908560968"></a><!-- doxytag: member="iPcSteer::GetPosition" ref="a76f68a340d625a4fc13c3c6908560968" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcSteer.html#a76f68a340d625a4fc13c3c6908560968">iPcSteer::GetPosition</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the end position that we want to move to. </p>

</div>
</div>
<a class="anchor" id="a6c64a03ed79142641b894e4afede85d5"></a><!-- doxytag: member="iPcSteer::GetSector" ref="a6c64a03ed79142641b894e4afede85d5" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="el" href="structiPcSteer.html#a6c64a03ed79142641b894e4afede85d5">iPcSteer::GetSector</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the end sector that we want to move to. </p>

</div>
</div>
<a class="anchor" id="a5eb951aa306ac8dacc60529f0f6219bf"></a><!-- doxytag: member="iPcSteer::Interrupt" ref="a5eb951aa306ac8dacc60529f0f6219bf" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a5eb951aa306ac8dacc60529f0f6219bf">iPcSteer::Interrupt</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Interrupt a movement. </p>
<p>The behaviour will get a 'pcsteer_interrupted' message if the mover was really moving. Otherwise nothing happens. </p>

</div>
</div>
<a class="anchor" id="a3726dbb6f2cdcbfddf00bfdf7e87922c"></a><!-- doxytag: member="iPcSteer::IsMoving" ref="a3726dbb6f2cdcbfddf00bfdf7e87922c" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcSteer.html#a3726dbb6f2cdcbfddf00bfdf7e87922c">iPcSteer::IsMoving</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if currently moving. </p>

</div>
</div>
<a class="anchor" id="a818c245703a5d6161741a869268aac22"></a><!-- doxytag: member="iPcSteer::Pursue" ref="a818c245703a5d6161741a869268aac22" args="(iCelEntity *target, float max_prediction)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcSteer.html#a818c245703a5d6161741a869268aac22">iPcSteer::Pursue</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>target</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max_prediction</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move to the specified targets position. </p>
<p>When you call this function this property class will attempt to move the linmove to the targets current position. The targets position will be updated periodically. Also, if max_prediction &gt; 0, this function will calculate targets future position instead of its actual position in order to have more chance to cacth its target. If arrival checking is activated it will stop at the specified position and it will get a 'pcsteer_arrived' message. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcsteer_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>is the desired target to pursue. </td></tr>
    <tr><td class="paramname">max_prediction</td><td>is the maximun prediction that can be used to calculate target's future position. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5a475bad4b23a3bf8afdbbbdde1b7312"></a><!-- doxytag: member="iPcSteer::RandomBinomial" ref="a5a475bad4b23a3bf8afdbbbdde1b7312" args="(float rate)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcSteer.html#a5a475bad4b23a3bf8afdbbbdde1b7312">iPcSteer::RandomBinomial</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>rate</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a random number using a random binomial. </p>

</div>
</div>
<a class="anchor" id="a0bf80ce6090221e90ab193110be32996"></a><!-- doxytag: member="iPcSteer::Seek" ref="a0bf80ce6090221e90ab193110be32996" args="(iSector *sector, const csVector3 &amp;position)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcSteer.html#a0bf80ce6090221e90ab193110be32996">iPcSteer::Seek</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move to the specified position. </p>
<p>When you call this function this property class will attempt to move the linmove to the correct position. If arrival checking is activated it will stop at the specified position and it will get a 'pcsteer_arrived' message. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcsteer_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sector</td><td>is the desired sector to move to. </td></tr>
    <tr><td class="paramname">position</td><td>is the desired position to move to. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a58bb89b7931f71aff132c9b28a6dcaac"></a><!-- doxytag: member="iPcSteer::SeparationOff" ref="a58bb89b7931f71aff132c9b28a6dcaac" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a58bb89b7931f71aff132c9b28a6dcaac">iPcSteer::SeparationOff</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Separation off. </p>

</div>
</div>
<a class="anchor" id="aa10962cc8efce907fe563dfb73539231"></a><!-- doxytag: member="iPcSteer::SeparationOn" ref="aa10962cc8efce907fe563dfb73539231" args="(iCelEntityList *targets, float radius, float weight)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#aa10962cc8efce907fe563dfb73539231">iPcSteer::SeparationOn</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntityList.html">iCelEntityList</a> *&#160;</td>
          <td class="paramname"><em>targets</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>radius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>weight</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets Separation on. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">targets</td><td>sets current separation_targets </td></tr>
    <tr><td class="paramname">radius</td><td>sets current separation_radius </td></tr>
    <tr><td class="paramname">weight</td><td>sets current separation_weight </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a284fa5c89e4d1a1db57b95cd11c480aa"></a><!-- doxytag: member="iPcSteer::SetDelayRecheck" ref="a284fa5c89e4d1a1db57b95cd11c480aa" args="(int delay)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcSteer.html#a284fa5c89e4d1a1db57b95cd11c480aa">iPcSteer::SetDelayRecheck</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>delay</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets current delay_recheck. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">delay</td><td>sets delay_recheck </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0394f8bb7728b4a63125cf03f2b948c2"></a><!-- doxytag: member="iPcSteer::Vigilant" ref="a0394f8bb7728b4a63125cf03f2b948c2" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcSteer.html#a0394f8bb7728b4a63125cf03f2b948c2">iPcSteer::Vigilant</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Stay vigilant about changes around. </p>
<p>Enables checking for collision and separation even when not moving. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="steer_8h_source.html">steer.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
